## 5.1 - Editando alguns parmetros grficos

saligna <- read.csv("esaligna.csv")
png("saligna.png")
plot(saligna$ht~saligna$dap)
par(las=1,pch=16, bty= "l", tcl=0.3, cex.axis=1.5, cex.lab=1.7)
plot(saligna$ht~saligna$dap, main= "Eucalypthus saligna", cex.main=1.8, xlab= "Dimetro  altura do peito (cm)", ylab = "Altura (m)", cex=1.4, col= "red")
dev.off()

## 5.2 - Dois grficos juntos

saligna <- read.csv("esaligna.csv")
png("doisgraficos.png")
par(mfrow=c(1,2))
par(las=1, bty= "l", tcl=0.3, cex.axis=1.5, cex.lab=1.5)
boxplot(saligna$dap~saligna$talhao,data = saligna, xlab= "Talho", ylab="Dimetro  altura do peito (cm)")
text(6.5,23,"A", family="serif", cex=1.7)
media <- tapply(saligna$dap,saligna$talhao,mean)
media
despad <- tapply(saligna$dap,saligna$talhao,sd)
despad
graf <- barplot(media, ylim= c(0,25), cex.main=1.8, xlab= "Talho", ylab="Dimetro  altura do peito (cm)")
segments(x0 = graf, y0= (media - despad), x1 = graf, y1= (media + despad))
text(7,24,"B", family="serif", cex=1.7)
dev.off()

## 5.3 - Adivinhando o cdigo

misterio <- read.csv("exercicio3.csv")
png("adivinhando.png")
## GRFICO 01 ##
par(mfrow=c(1,2))
plot(misterio$x1, misterio$y1, ylab="", xlab="Log(Patch size)(ha)", tcl=0.5, bty="l", xlim=c(0.5,2.2), ylim=c(0,3), pch=17, cex=1.7, cex.lab= 1.5,cex.axis=1.5, family="serif") 
segments(x=0.5, y= 2.25, x1=2.17, y1=1, lwd=3) 
mtext("Euclidean distances", 2, cex=1.8, family="serif", line=2.5) 
text(2.2,3,"a", family="serif", cex=1.7)
## GRFICO 02 ##
par(bty="l", mar=c(5,0.5,4,2))
boxplot(misterio$x2~misterio$y2,outline=F, xaxt="n", yaxt="n", ylim=c(0,3)) 
axis(1, labels=F, tcl=0.5) 
axis(2, labels=T, tcl=0.5, family="serif")
mtext(c("Small","Medium\n Edge","Medium\n Interior", "Large\n Edge","Large\n Interior","Control"), 1, at=1:6, line=1.5, family="serif") 
text(c(1:2, 4),3,"*", family="serif", cex=1.5) 
text(3,3,"**", family="serif", cex=1.5) 
text(5,3,"***", family="serif", cex=1.5) 
text(6.5,3,"b", family="serif", cex=1.5)
dev.off()
