saligna = read.csv("esaligna.csv")
quartz()

##########################################
# 5.1 Editando alguns parâmetros gráficos
########################################1
png(filename = "saligna.png",width = 1024, height = 1024, res = 172)
par(pch=16,  tcl=0.3,  bty="l", cex.main = 1.8, cex.axis = 1.4, las = 1)
plot(x = saligna$dap,y = saligna$ht, cex=1.4, xlab = "", ylab = "", main = "Eucalypthus saligna", col="#ff000040")
mtext(text ="Diametro a altura do peito (cm)", side = 1,line = 2.5, at =15, cex = 1.5) #não consegui exibir acentos no mac ainda
mtext(text ="Altura (m)", side = 2,line = 2.5, at =15, cex =1.5,las=3)
dev.off()

#########################
#5.2 Dois gráficos juntos
########################1
str(saligna)
saligna$talhao = as.factor(saligna$talhao)	
# range eixo y
ylim.max = max(saligna.plot$dap.media) + max(saligna.plot$dap.sd)

#parametros
par(pch=16,  tcl=0.3,  bty="l", cex.main = 1.8, cex.axis = 1.4, las = 1)
par(mfrow=c(1,2))
# plotando primeiro gráfico boxplot
boxplot(saligna$dap~saligna$talhao, ylim = c(0,25))
mtext("A", side = 3, cex=1.2)

# calculo de média e sd 
dap.media = tapply(saligna$dap, saligna$talhao, mean)
dap.sd = tapply(saligna$dap, saligna$talhao, sd)
# criando data.frame com valores para plot
saligna.plot = data.frame(dap.media,dap.sd)
# calculo para construção da barra de desvio padrao
barra.sd = data.frame(saligna.plot$dap.sd+saligna.plot$dap.media , saligna.plot$dap.media-saligna.plot$dap.sd)
# Plotando médias sem eixo x, com pontos cheios, e limite eixo y = média + sd
plot(saligna.plot$dap.media, pch=19,xaxt="n", ylim=c(0,25), xlab="Talhao", ylab ="Media")
# plotando eixo com valores de 
axis(side=1, at=c(1:6), labels=c(row.names(saligna.plot))) 
segments(x0 = 1:6, y0 = barra.sd[,1], x1 = (1:6), y1 = barra.sd[,2])
points (x=c(1:6), y=barra.sd[,1], pch= "_" ); points (x=c(1:6), y=barra.sd[,2], pch= "_" )
mtext("B", side = 3, cex=1.2)

#########################
# 5.3 Adivinhando o código
########################1
dados = read.csv("exercicio3.csv")
head(dados)

par(mfrow = c(1,2), tcl=0.4, family="serif" )
par(mar=c(4,4,2,1))
# Grafico 1
plot(x = dados$x1, y = dados$y1, bty="l", pch=17, xlim=c(0.5,2), ylim=c(0,3), ylab="", xlab="")
abline(lm(dados$y1~dados$x1),lwd=2)
mtext(text = "Euclidean distances", side = 2, line = 2, cex = 1.5)
mtext(text = "Log(Patch size)(ha)", side = 1, line = 2.5, cex = 1)
legend("topright",legend = "a", box.lty=0, cex = 1.5, inset = -0.03, bty = "n" )
# Grafico 2
par(mar=c(4,1.5,2,1))
boxplot(formula = dados$x2~dados$y2, ylim=c(0,3), outline=F, xaxt="n")
axis(side = 1,at=1:6,labels = c("Small","Medium\n Edge","Medium\nInterior", "Large\nEdge","Large\nInterior","Control"),cex=1)
legend("topright",legend = "b", box.lty=0, cex = 1.5, inset = -0.03)
text(x = c(1,2,4),y = rep(3,time=3), labels = "*")
text(x = c(3,5),y = rep(3,time=2), labels = "**")
