##############
# 4.2 Cervejas
cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")
factor(cervejas)

# Represente este resultado como um gráfico de barras e um dotplot (função dotchart).
par(mfrow=c(1,2))
barplot(table(cervejas))
dotchart(table(cervejas))
par(mfrow=c(1,1))

# Qual tem maior razão dado/tinta?
# Dot chart, pois aparentemente utiliza menos tinta para apresentar a mesma informção

##############
# 4.3 Caixetas
caixeta <- read.csv("caixeta.csv")
head(caixeta)
tail(caixeta)
str(caixeta)
hist(x = caixeta$fuste)

#Construa um histograma do dap dos fustes dos caixetais.
caixeta$dap = caixeta$cap/pi
hist(caixeta$dap)

# Construa histogramas da altura das árvores para os diferentes caixetais ('local').
par (mfrow= c(1,length(unique(caixeta$local))))
tapply(caixeta$h, caixeta$local, hist, main ="")
par (mfrow= c(1,1))

# Há diferenças entre as estruturas (distribuição de tamanhos) dos caixetais?
# Sim, aparentemente existe uma distribuição diferente em um dos caxetais

#################
# 4.4 Eucaliptos
dev.off()
#Utilize o gráfico boxplot para analisar o DAP de árvores de E. grandis em função das variáveis região (regiao) e rotação (rotacao).
egrandis <- read.csv("egrandis.csv", header = T, sep = ";")
head(egrandis)
str(egrandis)
boxplot(egrandis$dap ~ egrandis$regiao + egrandis$rotacao)

# Avalie a normalidade da altura do conjunto total de árvores com um gráfico quantil-quantil contra a distribuição normal.
qqnorm( egrandis$ht )
qqline( egrandis$ht )
# Os dados de altura não parecem seguir uma distribuição normal

####################
# 4.5 Mais Caixetais
####################
caixeta <- read.csv("caixeta.csv")
head(caixeta)
str(caixeta)
caixeta$dap <- caixeta$cap/pi

## 1. Analise a relação dap-altura ('dap' e 'h') em função do caixetal (local) com a função plot, mas somente para as árvores 2) de caixeta (Tabebuia cassinoides).
#############
#dataset apenas com dados de Tabebuia
caixeta.tebebuia = caixeta[caixeta$especie == "Tabebuia cassinoides",]
head(caixeta.tebebuia)
#par(mfrow = c(2,2))
plot(caixeta.tebebuia$dap~caixeta.tebebuia$h)

#usando base
par(mfrow = c(1,3))
plot(x = caixeta.tebebuia$dap[caixeta.tebebuia$local=="chauas"], y = caixeta.tebebuia$h[caixeta.tebebuia$local=="chauas"] )
plot(x = caixeta.tebebuia$dap[caixeta.tebebuia$local=="jureia"], y = caixeta.tebebuia$h[caixeta.tebebuia$local=="jureia"] )
plot(x = caixeta.tebebuia$dap[caixeta.tebebuia$local=="retiro"], y = caixeta.tebebuia$h[caixeta.tebebuia$local=="retiro"] )
par(mfrow = c(1,1))

#usando with
# subset dentro de plot() não funciona se for dado os parametros x e y ao invés da expressão
par(mfrow = c(1,3))
with(data = caixeta.tebebuia, expr = {
  plot(h~dap, subset = (local == "chauas"))
  plot(h~dap, subset = (local == "jureia"))
  plot(h~dap, subset = (local == "retiro"))
})


## 2. Para a mesma relação do item anterior, verifique linearidade com a função scatter.smooth
##################
#usando base
par(mfrow = c(1,3))
scatter.smooth(x = caixeta.tebebuia$dap[caixeta.tebebuia$local=="chauas"], y = caixeta.tebebuia$h[caixeta.tebebuia$local=="chauas"] )
scatter.smooth(x = caixeta.tebebuia$dap[caixeta.tebebuia$local=="jureia"], y = caixeta.tebebuia$h[caixeta.tebebuia$local=="jureia"] )
scatter.smooth(x = caixeta.tebebuia$dap[caixeta.tebebuia$local=="retiro"], y = caixeta.tebebuia$h[caixeta.tebebuia$local=="retiro"] )
par(mfrow = c(1,1))

#usando with ----> não funcionou,pq?
par(mfrow = c(1,3))
with(data = caixeta.tebebuia, expr = {
  scatter.smooth(h~dap, subset = (local == "chauas"))
  scatter.smooth(h~dap, subset = (local == "jureia"))
  scatter.smooth(h~dap, subset = (local == "retiro"))
})
par(mfrow = c(1,1))

## 3.Utilizando o pacote lattice, analise a relação dap-altura ('dap' e 'h') em função do caixetal (local), mas somente para as árvores 3) de caixeta (Tabebuia cassinoides).
#############
library(lattice)
xyplot(dap~h | local, data =  caixeta.tebebuia,  xlab="Altura", ylab="DAP", main="chauas")



