#####################
#### exercicio 1
#####################

eutad = read.table(file = "palmadulto.txt", header = T)
str(eutad)
head(eutad)

dist=matrix(NA, ncol=102, nrow=102)
for(i in 1:101){
  for(j in (i+1):102){
    difx2=(eutad$gx[i]-eutad$gx[j])^2
    dify2=(eutad$gy[i]-eutad$gy[j])^2
    dist[i,j]<-sqrt(difx2 + dify2)
    dist[j,i]<-sqrt(difx2 + dify2)
  }
}
# calcula o vizinho mais proximo de cada linha
(nn<-apply(dist, 1, min, na.rm=TRUE))
# calcula a media da dist do vizinho mais proximo
(mnn<-mean(nn))

##############
### simulando
#############

nsim = 1000
resultado = rep(NA, times = nsim)
resultado[1] = mnn
for (k in 2:nsim) { 
  xsim = round(runif(n = 102,max = 320, min = 0), 1)
  ysim = round(runif(n = 102,max = 320, min = 0), 1)
  dist.sim = matrix(NA, ncol=102, nrow=102)
  
  for (i in 1:101) { #linhas
    for (j in (i+1):102) { #colunas
      difx2.sim=(xsim[i]-xsim[j])^2
      dify2.sim=(ysim[i]-ysim[j])^2
      dist.sim[i,j]<-sqrt(difx2.sim + dify2.sim)
      dist.sim[j,i]<-sqrt(difx2.sim + dify2.sim)
    }
  }
  nn.sim = apply(dist.sim, 1, min, na.rm=TRUE)
  mnn.sim = mean(nn.sim)
  resultado[k] = mnn.sim
  
}

#plots
hist(resultado)
abline(v = mnn, col ="blue")
#legend(x = "topright", legend = "Média\n observada", fill = "blue")

#centralizando no 0
mnn = mnn - mean(resultado)
resultado = resultado - mean(resultado)

#calculando p
p.palmitos = (sum(resultado <= resultado[1] | resultado >= resultado[1]*-1))/nsim
p.palmitos

#####################
#### exercicio 2
#####################
animals = read.table("animais.txt", sep = ";", dec = ",")
animals = na.omit(animals)
str(animals)
head(animals)

# inclinação observada
b.obs = as.numeric(lm(log(brain)~log(body), data = animals)$coefficients[2])

#simulacao dados
nsim = 1000
animals.sim = rep(NA, times = nsim)
animals.sim[1] = b.obs
for (i in 2:nsim) {
  sim.brain = sample(animals$brain)
  animals.sim[i] = as.numeric(lm(log(sim.brain)~log(animals$body))$coefficients[2])
}

#plots
hist(animals.sim)
abline(v = b.obs, col="blue")

#calculo de probabilidade
p.animals = sum(animals.sim >= animals.sim[1] | animals.sim <= animals.sim[1]*-1)/nsim
p.animals
