#Exercicio 9.2 análise exploratoria simultanea de duas variaveis#
#dados para teste
x <- rnorm(100, 3, 2.5)
y <- runif(100, 3, 33)
simulexp <- function(x, y=NULL)
{
  if(is.null(y)){
    
    par(mfrow=c(1,2))
    hist(x, ylab="Frequência", xlab="Dados de x")
    qqnorm(x, ylab="Quantil da amostra", xlab="Quantil teórico")
    qqline(x, col="red")
    par(mfrow=c(1,1))
    Resumo <- list(summary(x))
    names(Resumo) <- "Resumo de x"
    return(Resumo)
  }
  else{ #plotando analise exploratoria so pra x
    
  if(length(x) != length(y))
  {stop("x e y têm comprimentos diferentes")}
  if((class(x)!= "numeric") | (class(y)!="numeric"))
  {stop("x e/ou y não é um vetor numérico")}
  
  par(mfrow=c(2,2))
  plot(y~x, pch=16, main="Relação y em função de x")
  boxplot(x, y, labels=NULL, names=c("x", "y"), main="Comparando x e y", col=c("blue", "orange"))
  hist(x, ylab="Frequencia", xlab="Dados de x", main=NULL, col=rgb(0,0,1, 0.3))
  hist(y, ylab="Frequencia", xlab="Dados de y", main=NULL, col=rgb(0.5,0.5,0, 0.3))
  par(mfrow=c(1,1))
  Resumo <- list(summary(x), summary(y))
  corr <- list(cor(x, y))
  names(Resumo) <- c("Resumo de x", "Resumo de y")
  names(corr) <- "Coeficiente de correlação"
  return(list(Resumo, corr))
  }
}

simulexp(x)
simulexp(x, y)
