##### 4.2 Cervejas #####

cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")
str(cervejas)

## 4.2.1. Represente este resultado como um grafico de barras e um dotplot (função dotchart)

table(cervejas)
par(mfrow=c(1,1))
barplot(table(cervejas))
dotchart(table(cervejas))

## 4.2.2. Qual tem maior razao dado/tinta?

#Em ambos conseguimos extrair boa parte das informacoes, mas o dotchart 
#usa "menos tinta" pra nos informar. Ou seja, tem maior razao dado/tinta.

##### 4.3 CAIXETAIS #####

caixeta <- read.table("caixeta.csv", sep = ",", dec=".", header = T, as.is = T)
head(caixeta)
str(caixeta)

## 4.3.1 Construa um histograma do dap dos fustes dos caixetais.

caixeta$dap <- caixeta$cap/pi
head(caixeta)
caixeta$local <- as.factor(caixeta$local)
dapsum.arv <- aggregate(dap, by=list(Arvore=caixeta$arvore, Local=caixeta$local), sum)
head(dapsum.arv)
str(dapsum.arv)
par(mfrow=c(1,1))
?hist
hist(dapsum.arv$x, xlab="DAP", ylab="Frequencia", main="Histograma dos DAPS dos caixetais")

## 4.3.2 Constra histogramas da altura das arvores para os diferentes caixetais("local")

table(caixeta$local)
?hist
Chauas <- caixeta[caixeta$local=="chauas",]
hsum.arv.c <- aggregate(Chauas$h, by=list(Arvore=Chauas$arvore), sum)
hsum.arv.c
Jureia <- caixeta[caixeta$local=="jureia",]
hsum.arv.j <- aggregate(Jureia$h, by=list(Arvore=Jureia$arvore), sum)
hsum.arv.j
Retiro <- caixeta[caixeta$loca=="retiro",]
hsum.arv.r <- aggregate(Retiro$h, by=list(Arvore=Retiro$arvore), sum)
hsum.arv.r

par(mfrow=c(1,3))

hist(hsum.arv.c$x, xlab="Altura", main="Chauas")
hist(hsum.arv.j$x, xlab="Altura", main="Jureia")
hist(hsum.arv.r$x, xlab="Altura", main="Retiro")

## 4.3.3 Ha diferencas entre as estruturas (distribuicao de tamanhos) dos caixetais?

#Não, em geral as alturas das arvores em todos os locais apresentam muitos valores
#"pequenos" e poucos valores muito elevados, formando uma cauda longa para a direita.

##### 4.4 EUCALIPTOS #####

egrandis <- read.table("egrandis.csv", sep = ";", header = T, as.is = T)
head(egrandis)
str(egrandis)

## 4.4.1 Utilize o gráfico boxplot para analisar o DAP de arvores de E. grandis 
#em funcao das variaveis regiao (regiao) e rotacao (rotacao).

egrandis$regiao <- as.factor(egrandis$regiao)
egrandis$rotacao <- as.factor(egrandis$rotacao)
table(egrandis$regiao)
table(egrandis$rotacao)
summary(egrandis$dap)
par(mfrow=c(1,1))
?boxplot
boxplot(dap~regiao+rotacao, data=egrandis)

## 4.4.2 Avalie a normalidade da altura do conjunto total de árvores com 
#um gráfico quantil-quantil contra a distribuição normal.

?qqnorm
qqnorm(egrandis$ht, pch=16)
qqline(egrandis$ht, col="red")

#O grafico resultante da funcao qqnorm e a linha proposta pela funcao qqline
#sugerem que os dados de altura dos eucaliptos nao seguem uma distribuicao normal
#porque os pontos nao estao todos alinhados com a linha teorica de distribuicao normal.
#A distribuicao dos pontos no grafico sugerem que o conjunto de dados apresenta uma
#cauda curta a esquerda e uma cauda longa a direita da distribuicao, como por ser
#observado no histograma fornecido por hist(egrandis$ht):
hist(egrandis$ht)

##### 4.5 MAIS CAIXETAIS #####

# 4.5.1 Analise a relacao dap-altura ('dap' e 'h') em funcao do caixetal (local) 
#com a funcao plot, mas somente para as arvores de caixeta (Tabebuia cassinoides)

tcassi <- caixeta[caixeta$especie == "Tabebuia cassinoides",] #obj so com caixetas
tcassi <- subset(caixeta, especie == "Tabebuia cassinoides", select=c("arvore","h","local","dap")) #outra forma de fazer e selecionar só algumas colunas
head(tcassi)
str(tcassi)
tcassi$local <- as.factor(tcassi$local)
?plot
par(mfrow=c(1,3))
with(tcassi[tcassi$local=="chauas",], plot(dap~h, xlab="Altura", ylab="DAP", main="Chauas"))
with(tcassi[tcassi$local=="jureia",], plot(dap~h, xlab="Altura", ylab="DAP", main="Jureia"))
with(tcassi[tcassi$local=="retiro",], plot(dap~h, xlab="Altura", ylab="DAP", main="Retiro"))

# 4.5.2 Para a mesma relacao do item anterior, verifique linearidade com a funcao scatter.smooth
?scatter.smooth
with(tcassi[tcassi$local=="chauas",], scatter.smooth(tcassi[tcassi$local=="chauas", "dap"]~tcassi[tcassi$local=="chauas", "h"], xlab = "Altura", ylab = "DAP", main="Chauas"))
with(tcassi[tcassi$local=="jureia",], scatter.smooth(tcassi[tcassi$local=="jureia", "dap"]~tcassi[tcassi$local=="jureia", "h"], xlab = "Altura", ylab = "DAP", main="Jureia"))
with(tcassi[tcassi$local=="retiro",], scatter.smooth(tcassi[tcassi$local=="retiro", "dap"]~tcassi[tcassi$local=="retiro", "h"], xlab = "Altura", ylab = "DAP", main="Retiro"))
#Aparentemente existe uma relacao linear, mas há um valor outlier enviesando os dados da localidade "Chauas"

#4.5.3 Utilizando o pacote lattice, analise a relação dap-altura ('dap' e 'h') 
#em função do caixetal (local), mas somente para as árvores de caixeta (Tabebuia cassinoides).

library(lattice)
?xyplot
xyplot(dap~h|local, data=tcassi, xlab="DAP", ylab="Altura")
