##### Exercicios 5 - Criacao de graficos #####

## 5.1 Editando alguns parametros graficos ##

saligna <- read.table("esaligna.csv", sep=",", dec=".", header=T, as.is=T)
head(saligna)

png("saligna.png")
par(pch=16, mai=c(1.02, 1, 0.82, 0.42), #usei mai= pra corrigir a margem esquerda
    cex.axis= 1.5, #cex.axis <- tam dos nums no eixo
    cex.lab=1.7, #cex.lab <- tam font labels dos eixos
    tcl=0.3, las=1, bty="l",
    cex.main=1.8)

plot(ht~dap, data=saligna, col="red", cex=1.4,
     xlab="Diâmetro à altura do peito (cm)", 
     ylab="Altura (m)",
     main="*Eucalypthus saligna*")
dev.off()
#Salvo em png() logo apos dev.off()

## 5.2 Dois graficos juntos ##
med.tal <- aggregate(dap~talhao, mean, data=saligna)
med.tal
sd.tal <- aggregate(dap~talhao, sd, data=saligna)
sd.tal

par(mfrow=c(1,2))
par(pch=16, 
    cex.axis= 1, #cex.axis <- tam dos nums no eixo
    cex.lab=1.5, #cex.lab <- tam font labels dos eixos
    mar=c(4.5,5,4,4),
    tcl=0.3, las=1, bty="l",
    cex.main=1.8)
boxplot(dap~talhao, data=saligna,
        xlab="Talhão", ylab="Diâmetro à altura do peito")
plot(1:nrow(med.tal), med.tal$dap, xaxt="n",
     ylim=c(0, 23), col="red", cex=1.4, pch=16,
     xlab="Talhão", ylab="Diâmetro à altura do peito")
axis(1, at=1:6, labels=med.tal$talhao)

arrows(1:nrow(med.tal), med.tal$dap-sd.tal$dap, 
       1:nrow(med.tal), med.tal$dap+sd.tal$dap, 
       length=0.05, angle=90, code=3)

## 5.3 Adivinhando o codigo ##

#Preparando os dados
dados <- read.table("dados.csv", sep=",", dec=".", header=TRUE, as.is=TRUE)
head(dados)
tail(dados)
str(dados)
summary(dados)
md <- lm(y1~x1, data=dados)
summary(md)

#Construindo o primeiro grafico:
par(mfrow=c(1,2)) #parametro para os dois graficos aparecerem lado a lado
par(mai=c(1.02, 0.82, 0.82, 0.0))
plot(y1~x1, data=dados, pch=17, col="black", 
     ylab="", xlab="",
     ylim=c(0,3.0), xlim=c(0.5,2.2), 
     bty="l", tcl=0.3, mgp=c(0,0,0),
     mar=c(5.1, 5.1, 4.1,0))
mtext("Log(Patch size)(ha)", side=1, at=1.3, line=1.5, family="serif", cex=1.4) #Legendas
mtext("Euclidian distances", side=2, at=1.5, line=1.5, family="serif", cex=2)
arrows(0.5, 2.2,2.2, 0.95, lwd=3, angle=0) #adicionando a linha
#abline(md, lwd=3)#Tentei com abline, mas a reta dava com inclinacao diferente da imagem e colava no Y
text(2.2, 3.0, "a", cex=2, family="serif") #adicionando o "a" da figura


### Construindo o Boxplot ###
par(bty="l", tcl=0.3, mai=c(1.02, 0.50, 0.82, 0.42)) #Parametros globais
boxplot(x2~y2, data=dados, outline=F, #outline=F tira outliers,
        ylab="", xlab="", xaxt="n", #xaxt="n" nao plota eixo x
        ylim=c(0, 3.0))
axis(1, at=c(1:6), family="serif",mgp=c(0, 1.5, 0), cex = 1.3, #criando eixo x novo
     labels=c("Small", "Medium\nEdge", "Medium\nInterior", "Large\nEdge", "Large\nInterior", "Control"))
text(6.5, 3.0, "b", cex=2, family="serif") #adicionando os simbolos restantes
text(1, 3, "*", cex=2, family="serif")
text(2, 3, "*", cex=2, family="serif")
text(3, 3, "**", cex=2, family="serif")
text(4, 3, "*", cex=2, family="serif")
text(5, 3, "***", cex=2, family="serif")
