### Exercicio 7b - Regressao multipla ###

#############################################################
##### Uma estimativa da incerteza na previsao do modelo #####
#############################################################

bbs <- read.table("babies.txt", sep="", dec=".", header=T, as.is=T)
head(bbs) #dando uma olhada nos dados
str(bbs)
summary(bbs)

bb <- bbs[bbs$gestation<999 & bbs$parity<9 & bbs$age<99 & bbs$height<99
          & bbs$weight<999 & bbs$smoke<9,] #removendo os faltantes
summary(bb) #nova olhada nos dados

lm.bb <- lm(bwt~gestation, data=bb)
summary(lm.bb) #criando e olhando o resumo do modelo

sqprev <- seq(min(bb$gestation)-30, max(bb$gestation)+30, length=100) #criando sequencia para eixo x

arg1 <- var(bb$bwt)
arg2 <- 1/length(bb$gestation)
arg3 <- ((sqprev-mean(bb$gestation))^2)/(sum((bb$gestation-mean(bb$gestation))^2))
sd2 <- sqrt(arg1*(arg2+arg3)) #Calculo do erro padrao

tval <- qt(0.025, length(bb$gestation)-2, lower.tail = F) #Calculo do valor de t para 95% e n-2gl
ic <- tval*sd2 #intervalo de confiança
ypred <- predict(lm.bb, newdata= data.frame(gestation=sqprev))

#Fazendo o grafico com o intervalo de confianca de 95% dos preditos
plot(bwt~gestation, data=bb, cex=0.3, col="blue", bty="l", pch=16,
     ylab="Peso do bebê (Kg)", xlab="Tempo de gestação (dias)")

abline(lm.bb, col="red")
polygon(c(rev(sqprev), sqprev), c(rev(ypred-ic), ypred+ic), col=rgb(0,0,0, 0.3))

#outro jeito (precisa de interval='confidence' no predict)
polygon(c(rev(sqprev), sqprev), c(rev(ypred[,2]), ypred[,3]), col=rgb(0,0,0, 0.3))

##################################
###### Galileu estava certo? #####
#################################

#retomando os dados:
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

mod2 <- lm(h.d~init.h + I(init.h^2))
mod3 <- lm(h.d~init.h + I(init.h^2)+I(init.h^3))
anova(mod2, mod3) #diferenca significativa

#Resp.: O modelo com polinomio de terceiro grau eh um modelo melhor 
#para descrever os dados de Galileu.

##############################################
########### Massa de recem-nascidos ##########
##############################################

#retomando dados bebes:
bbs <- read.table("babies.txt", sep="", dec=".", header=T, as.is=T)
head(bbs) #dando uma olhada nos dados
str(bbs)
summary(bbs)

bb <- bbs[bbs$gestation<999 & bbs$parity<9 & bbs$age<99 & bbs$height<99
          & bbs$weight<999 & bbs$smoke<9,] #removendo os faltantes
summary(bb) #nova olhada nos dados

#Comecando do modelo cheio:
lm0 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
          +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
          +height:weight+height:smoke+weight:smoke+gestation:age:height+gestation:age:weight
          +gestation:age:smoke+age:height:weight+age:height:smoke+age:weight:smoke, data=bb)
anova(lm0)

###Retirando e testando interacoes triplas###
#sem age:weight:smoke
lm1 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
          +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
          +height:weight+height:smoke+weight:smoke+gestation:age:height+gestation:age:weight
          +gestation:age:smoke+age:height:weight+age:height:smoke, data=bb)
anova(lm0, lm1) #fica com lm1

#sem age:height:smoke
lm2 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
          +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
          +height:weight+height:smoke+weight:smoke+gestation:age:height+gestation:age:weight
          +gestation:age:smoke+age:height:weight+age:weight:smoke, data=bb)
anova(lm0, lm2) #fica com lm2

#sem age:height:weight
lm3 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
   +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
   +height:weight+height:smoke+weight:smoke+gestation:age:height+gestation:age:weight
   +gestation:age:smoke+age:height:smoke+age:weight:smoke, data=bb)
anova(lm0, lm3) #fica com lm3

#sem gestation:age:smoke
lm4 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
          +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
          +height:weight+height:smoke+weight:smoke+gestation:age:height+gestation:age:weight
          +age:height:weight+age:height:smoke+age:weight:smoke, data=bb)
anova(lm0, lm4) #fica com lm4

#sem +gestation:age:weight
lm5 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
                 +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
                 +height:weight+height:smoke+weight:smoke+gestation:age:height
                 +gestation:age:smoke+age:height:weight+age:height:smoke+age:weight:smoke, data=bb)
anova(lm0, lm5) #fica com lm5

#sem gestation:age:height
lm6 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
          +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
          +height:weight+height:smoke+weight:smoke+gestation:age:weight
          +gestation:age:smoke+age:height:weight+age:height:smoke+age:weight:smoke, data=bb)
anova(lm0, lm6) #estranho

###Todas as triplas podem ser removidas###
lm7 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
                 +gestation:weight+gestation:smoke+age:height+age:weight+age:smoke
                 +height:weight+height:smoke+weight:smoke, data=bb)
anova(lm7)

#Tirando as interacoes duplas:
#Tirando age:height
lm8 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
          +gestation:weight+gestation:smoke+age:weight+age:smoke
          +height:weight+height:smoke+weight:smoke, data=bb)
summary(lm8)
anova(lm7, lm8) #fica com lm8

#Tirando weight:smoke
lm9 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
         +gestation:weight+gestation:smoke+age:weight+age:smoke
         +height:weight+height:smoke, data=bb)
summary(lm9)
anova(lm8, lm9) #fica com lm9

#Tirando height:weight
lm10 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
           +gestation:weight+gestation:smoke+age:weight+age:smoke
           +height:smoke, data=bb)
summary(lm10)
anova(lm9, lm10) #fica com lm10

#Tirando age:weight
lm11 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
           +gestation:weight+gestation:smoke+age:smoke
           +height:smoke, data=bb)
anova(lm10, lm11) #fica com lm11
summary(lm11)

#Tirando age:smoke
lm12 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
           +gestation:weight+gestation:smoke+height:smoke, data=bb)
anova(lm11, lm12) #fica com lm12
summary(lm12)

#Tirando height:smoke
lm13 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:height
           +gestation:weight+gestation:smoke, data=bb)
anova(lm12, lm13) #fica com lm13
summary(lm13)

#Tirando gestation:height
lm14 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:smoke, data=bb)
anova(lm13, lm14) #fica com lm14
summary(lm14)

#Tirando gestation:smoke
lm15 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age, data=bb)
anova (lm14, lm15) #FICA COM MAIS COMPLEXO LM14

#Tirando gestation:age
lm16 <- lm(bwt~gestation+age+height+weight+smoke+gestation:smoke, data=bb)
anova(lm14, lm16) #FICA COM O MAIS COMPLEXO LM14

##### Modelo minimo adequado: #####

lm14 <- lm(bwt~gestation+age+height+weight+smoke+gestation:age+gestation:smoke, data=bb)
summary(lm14)