## Exercícios 8. Reamostragem e Simulação ##

###### Exercicio 1 #####

eutad <- read.table("palmadulto.txt", sep="", dec=".", header=T, as.is=T)
head(eutad)
str(eutad)
sum(is.na(eutad))

#criando arquivo pra guardar as distancias entre cada individuo:
dist <- matrix(NA, ncol=102, nrow=102)    

#calculando a distancia observada entre cada individuo e guardando em dist:

for(i in 1:101)
{
  for(j in (i+1):102)
  {
    difx2 <- (eutad$gx[i]-eutad$gx[j])^2
    dify2 <- (eutad$gy[i]-eutad$gy[j])^2
    dist[i,j] <- sqrt(difx2 + dify2) #pitagoras soma dos ^2 dos catetos=^2 da hip
    dist[j,i] <- sqrt(difx2 + dify2) #pitagoras
  }
  
}

dist[1:10]

#calculando distancia media do vizinho mais proximo:

nn <- apply(dist, 1, min, na.rm=TRUE) ## nearest neighbor
mnn <- mean(nn) ## mean nearest neighbor

#simulando: agora lascou#
#tem um pseudo-codigo na pagina da disciplina

resultado <- rep(NA, 1000) #1.5
resultado[1] <- mnn #1.6

for(k in 2:1000){
  print(k)
  xsim <- round(runif(102, 0, 320), 1) #1.8.1
  ysim <- round(runif(102, 0, 320), 1) #1.8.2
  mxy <- matrix(NA, ncol=102, nrow=102) #1.8.3
    for(i in 1:101){
      for(j in (i+1):102){
      difx2 <- (xsim[i]-xsim[j])^2
      dify2 <- (ysim[i]-ysim[j])^2
      mxy[i,j] <- sqrt(difx2 + dify2) #pitagoras soma dos ^2 dos catetos=^2 da hip
      mxy[j,i] <- sqrt(difx2 + dify2) #pitagoras
      }
    }
  resultado[k] <- mean(apply(mxy, 1, min, na.rm=TRUE))
}

res <- resultado-mean(resultado)
hist(resultado)
hist(res)
abline(v=mnn[1], col="red", lty=2) #pra hist(resultado)
abline(v=res[1], col="red", lty=2) #pra hist(res)

ntrues <- sum(abs(res) >= abs(res[1]))
p <- ntrues/length(res)
p

#Uma pira extra: calculo de p sem padronizar pela media. 
c.mnn <- mean(resultado)+(mean(resultado)-mnn)
ntrues.2 <- sum(resultado <= mnn | resultado >= c.mnn)
p.2 <- ntrues.2/length(resultado)
p.2

hist(resultado)
abline(v=mnn, col="red", lty=2)
abline(v=mean(resultado)+(mean(resultado)-mnn), col="red", lty=2) #pra hist(resultado)
rect(mnn, 0, c.mnn, 240, col=rgb(0.2, 0.8, 0, 0.1), border=F)

##### Exercicio 2. Simulando o teste de uma regressao linear ######

ani <- read.table("animais.txt", sep=";", dec=",", header=T, as.is=T)
head(ani)
str(ani)

anim <- ani[!is.na(ani$brain),]
l.brain <- log(anim$brain)
l.body <- log(anim$body)

b <- sum((l.body-mean(l.body))*(l.brain-mean(l.brain))/sum((l.body-mean(l.body))^2))

lm0 <- lm(log(brain)~log(body), data=anim) #pra conferir o b
summary(lm0)
plot(lm) #diagnostico rapidex

sim <- rep(NA, 1000) #vetor pra guardar o resultado da simulacao
sim[1] <- b #colocando o valor de b na primeira posicao

for(i in 2:1000)
{
  sim_brain <- sample(l.brain)
  sim[i] <- sum((l.body-mean(l.body))*(sim_brain-mean(sim_brain))/sum((l.body-mean(l.body))^2))
}

hist(sim)
abline(v=b, col="red", lty=2)
summary(sim)
p <- sum(abs(sim) >= abs(sim[1]))/length(sim)
p
