#### 4.2 - Cervejas
cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma",
             "lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata",
             "chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa",
             "chope","garrafa","lata","lata")
count <- table(cervejas)

# 1. Represente este resultado como um gráfico de barras e um dotplot (função dotchart).
dotchart(count)

# 2. Qual tem maior razão dado/tinta?
  # A maior razao é de "garrafa"
razao = sort(count/sum(count))
razao
razao[4]


#### 4.3 Caixetaiss
caixeta <- read.csv("caixeta.csv", sep=",")
caixeta
dap <- caixeta$cap/pi
caixeta <- cbind(caixeta, dap)
area.basal.fuste <- pi*((caixeta$dap/2)^2)
area.basal.fuste
caixeta <- cbind(caixeta, area.basal.fuste)
area.basal.arv <- aggregate(caixeta$area.basal.fuste, by=list(caixeta$local, caixeta$especie,
                                                              caixeta$h, caixeta$arvore), sum)
area.basal.arv
names(area.basal.arv) <- c("local", "especie", "h","arvore", "area.basal.soma")
range(caixeta$arvore)
range(area.basal.arv$arvore)
dap.arvore <- 2*(sqrt((area.basal.arv$area.basal.soma)/pi))
area.basal.arv <- cbind(area.basal.arv, dap.arvore)

# 1. Construa um histograma do dap dos fustes dos caixetais.
# Todos os locais:
hist(caixeta$dap)
# Por local:
chauas <- caixeta[caixeta$local %in% ("chauas"),]
chauas
hist(chauas$dap, xlab="dap", main = paste("Chauas"))
jureia <- caixeta[caixeta$local %in% ("jureia"),]
jureia
hist(jureia$dap, xlab="dap", main = paste("Jureia"))
retiro <- caixeta[caixeta$local %in% ("retiro"),]
retiro
hist(retiro$dap, xlab="dap", main = paste("Retiro"))

# 2. Construa histogramas da altura das árvores para os diferentes caixetais ('local').

chauas2 <- aggregate(chauas$h, by=list(chauas$arvore), max)
head(chauas2)
names(chauas2) <- c("arvore", "h")
hist(chauas2$h, xlab="h", main = paste("Chauas"))
jureia2 <- aggregate(jureia$h, by=list(jureia$arvore), max)
head(jureia2)
names(jureia2) <- c("arvore", "h")
hist(jureia2$h, xlab="h", main = paste("Jureia"))
retiro2 <- aggregate(retiro$h, by=list(retiro$arvore), max)
head(retiro2)
names(retiro2) <- c("arvore", "h")
hist(retiro2$h, xlab="h", main = paste("Retiro"))
range(chauas2$h)
range(jureia2$h)
range(retiro2$h)

# 3. Há diferenças entre as estruturas (distribuição de tamanhos) dos caixetais?
  # Sim, as distribuiçoes sao diferentes


#### 4.4 Eucaliptos
egrandis <- read.csv("egrandis.csv", sep=";")
egrandis

# 1. Utilize o gráfico boxplot para analisar o DAP de árvores de E. grandis em função das variáveis
#região (regiao) e rotação (rotacao).
table (egrandis$regiao)
table (egrandis$rotacao)
boxplot(egrandis$dap ~ egrandis$regiao, xlab = "Regiao", ylab = "dap")
boxplot(egrandis$dap ~ egrandis$rotacao, xlab = "Rotacao", ylab = "dap")

# 2. Avalie a normalidade da altura do conjunto total de árvores com um gráfico quantil-quantil contra
#a distribuição normal.
?qqnorm
plot <- qqnorm(egrandis$ht)
cor(plot$x, plot$y) # correlacao = 0.96.
qqline(egrandis$ht, col = 2)


#### 4.5 Mais Caixetais

# 1. Analise a relação dap-altura ('dap' e 'h') em função do caixetal (local) com a função plot, mas
#somente para as árvores de caixeta (Tabebuia cassinoides).

area.basal.arv # data.frame construido no exercicio 4.3 contendo os dados das arvores individuais para
#cada local
par(mfrow=c(1,3))

# Para Chauas:
chauas3 <- area.basal.arv[area.basal.arv$local %in% list("chauas"),] # novo data frame contando os dados de Chauas, apenas
chauas.T.cas <- chauas3[chauas3$especie %in% list("Tabebuia cassinoides"),] # novo data frame contando os dados de T. cas, apenas
head(chauas.T.cas)
plot(chauas.T.cas$dap.arvore, chauas.T.cas$h, xlab="dap", ylab="h", main=paste("Chauas")) # plot

# Para Jureia:
jureia3 <- area.basal.arv[area.basal.arv$local %in% list("jureia"),]
jureia.T.cas <- jureia3[jureia3$especie %in% list("Tabebuia cassinoides"),]
head(jureia.T.cas)
plot(jureia.T.cas$dap.arvore, jureia.T.cas$h, xlab="dap", ylab="h", main=paste("Jureia"))

# Para Retiro:
retiro3 <- area.basal.arv[area.basal.arv$local %in% list("retiro"),]
retiro.T.cas <- retiro3[retiro3$especie %in% list("Tabebuia cassinoides"),]
head(retiro.T.cas)
plot(retiro.T.cas$dap.arvore, retiro.T.cas$h, xlab="dap", ylab="h", main=paste("Retiro"))

# Daria pra fazer sem os data frames local.T.cas (intermediarios), mas o comando fica muito grande:
plot((retiro3[retiro3$especie %in% list("Tabebuia cassinoides"),])$dap.arvore, (retiro3[retiro3$especie %in% list("Tabebuia cassinoides"),])$h, xlab="dap", ylab="h", main=paste("Retiro"))

# 2. Para a mesma relação do item anterior, verifique linearidade com a função scatter.smooth
?scatter.smooth

scatter.smooth(chauas.T.cas$dap.arvore, chauas.T.cas$h, xlab="dap", ylab="h", main=paste("Chauas"), lpars =
                 list(col = "red"))
scatter.smooth(jureia.T.cas$dap.arvore, jureia.T.cas$h, xlab="dap", ylab="h", main=paste("Jureia"), lpars =
                 list(col = "red"))
scatter.smooth(retiro.T.cas$dap.arvore, retiro.T.cas$h, xlab="dap", ylab="h", main=paste("Retiro"), lpars =
                 list(col = "red"))  

par(mfrow=c(1,1))

# 3. Utilizando o pacote lattice, analise a relação dap-altura ('dap' e 'h') em função do caixetal
#(local), mas somente para as árvores de caixeta (Tabebuia cassinoides).

library(lattice)
help("lattice-package")
str(retiro.T.cas)
xyplot(area.basal.arv$h ~ area.basal.arv$dap.arvore | area.basal.arv$local, xlab="dap", ylab="h")
