setwd("~/Desktop/R/Curso_Eco/Exercicios_tabela/")

#### Exercícios 5 - Criação de Gráficos

# 5.1 Editando alguns parâmetros gráficos

saligna <- read.csv("esaligna.csv", sep = ",")
saligna
?plot
?par

png(filename = "saligna.png", width = 480, height = 480, units = "px", pointsize = 12, bg = "white",
    res = NA)
par(mfrow = c(1,1), mar = c(5,5,5,5))
plot(ht ~ dap, data = saligna, xlab = "Altura (m)", ylab = "Diâmetro à altura do peito (cm)", 
     cex = 1.4, col = "red", pch = 16, bty = "l", cex.lab = 1.7, cex.axis = 1.5, cex.main = 1.8, 
     tcl = 0.3, las = 1, main = expression(paste(italic("Eucalypthus saligna"))))
dev.off()

# 5.2 Dois gráficos juntos

quartz()
par(mfrow = c(1,2), mar = c(5,5,5,2))
boxplot(dap ~ talhao, data = saligna, xlab = "talhão", ylab = "dap", cex = 1.4, col = "red", pch = 16,
        bty = "l", cex.lab = 1.7, cex.axis = 1.5, cex.main = 1.8, tcl = 0.3, las = 1)
text(x = 0.6, y = 22, labels = "a")
media.dap <- aggregate(saligna$dap, by = list(saligna$talhao), mean)
dp.dap <- aggregate(saligna$dap, by = list(saligna$talhao), sd)
media.dap <- cbind(media.dap, dp.dap$x)
names(media.dap) = c("talhao", "media", "dp")
media.dap
my.plot <- barplot(media.dap$media, names.arg = media.dap$talhao, xlab = "talhão", ylab = "media dap",
                   cex = 1.4, pch = 16, bty = "l", cex.lab = 1.7, cex.axis = 1.5, cex.main = 1.8, 
                   tcl = 0.3, las = 1, col = "red", ylim = c(0, 22))
arrows(my.plot, media.dap$media-media.dap$dp, my.plot, media.dap$media+media.dap$dp,angle = 90,
       code = 3, length = 0.1)
text(x = 0.3, y = 20, labels = "b")
dev.off()
my.plot

# 5.3 Adivinhando o código

arquivo <- read.csv("arquivo.csv", sep = ",")
arquivo

quartz()
par(mfrow = c(1,2), family = "Times", tcl = 0.5, mar = c(5,5,5,2), bty = "l")
modelo <- lm(y1 ~ x1, data = arquivo)
plot(y1 ~ x1, data = arquivo, xlim = c(0.5, 2.2), ylim = c(0, 3.0), pch = 17, xlab = "", ylab = "", cex = 1.5)
     #ylab = "Euclidean distances", pch = 17, cex.lab = 1.3, font.lab = 2)
abline(modelo)
mtext(text = "Euclidean distances", side = 2, line =2.5, cex = 1.5, font = 2)
mtext(text = "Log(Patch size)(ha)", side = 1, cex = 1.2, line = 2.5)
text(x = 2.2, y = 3, labels = "a", cex = 2)
par(mar = c(5,0,5,5))
my.boxplot <- boxplot(x2 ~ y2, data = arquivo, ylim = c(0, 3.0), na.rm = T, outline = F,
        names = c("Small","Medium\nEdge","Medium\nInterior","Large\nEdge","Large\nInterior","Control"),
        cex.axis = 0.9)
text(x = 6.5, y = 3, labels = "b", cex = 2)
text(x = 1, y = 3, labels = "*", cex = 2)
text(x = 2, y = 3, labels = "*", cex = 2)
text(x = 3, y = 3, labels = "**", cex = 2)
text(x = 4, y = 3, labels = "*", cex = 2)
text(x = 5, y = 3, labels = "***", cex = 2)
dev.off()
