#### Exercícios 8. Reamostragem e Simulação

## Exercício 1.

# Lendo os dados
eutad <- read.table("palmadulto.txt", header = TRUE, sep = "\t")
head(eutad)
length(eutad$tag)

# Criando a matriz de distancias e preenchendo
dist <- matrix(NA, ncol = 102, nrow = 102)
dist[1:10, 1:10]

for(i in 1:101)
{
  for(j in (i+1):102) # Começa em 2 pq o 1 vai ser NA (dist do individuo a ele mesmo). O preenchimento vai ser so
    #+ do triangulo superior da matriz
  {
    difx2 <- (eutad$gx[i] - eutad$gx[j])^2
    dify2 <- (eutad$gy[i] - eutad$gy[j])^2
    dist[i,j] <- sqrt(difx2 + dify2)
    dist[j,i] <- sqrt(difx2 + dify2)
  }
  
}

dist[1:10, 1:10]

(nn <- apply(dist, 1, min, na.rm=TRUE)) # Pegando as menores distancias ao vizinho mais proximo para cada individuo
(mnn <- mean(nn)) # Media das distancias ao vizinho mais proximo

# 1.5. Crie um vetor resultado, com 1000 NA's, para guardar os valores de cada simulação.
sim <- rep(NA, 1000)

# 1.6. Guarde o valor observado na primeira posição de resultado;
sim[1] <- mnn
sim

# 1.7. Crie um ciclo com contador (k) que vai de 2 a 1000;
for (k in 2:1000)
{
  xsim <- round(runif(102, 0, 320), 1)
  ysim <- round(runif(102, 0, 320), 1)
  distsim <- matrix(NA, ncol = 102, nrow = 102)
  for(i in 1:101)
  {
    for(j in (i+1):102)
    {
      difxsim <- (xsim[i] - xsim[j])^2
      difysim <- (ysim[i] - ysim[j])^2
      distsim[i,j] <- sqrt(difxsim + difysim)
      distsim[j,i] <- sqrt(difxsim + difysim)
    }
  }
  min.sim <- apply(distsim, 1, min, na.rm=TRUE)
  media.sim <- mean(min.sim)
  sim[k] <- media.sim
}
sim

# 1.9. Faça um histograma dos valores simulados e coloque uma linha vermelha vertical na posição do valor observado;
quartz()
par(mfrow=c(1,1))
hist(sim)
abline(v=sim[1], col="red")


# 1.10. Calcule a probabilidade de uma distribuição espacial aleatória gerar valores iguais ou mais extremos do que
#+ o valor MNN observado.

# Para valores iguais ou mais extremos (bilateral):
# Calcular a media dos valores encontrados na simulacao
media <- mean(sim)
sim.sim <- sim - media

# Plotando os valores (media agora = zero)
hist(sim.sim)
abline(v = sim.sim[1], col = "red")

# Calculo do p.valor
m.mnn <- sum(abs(sim.sim) >= abs(sim.sim[1]))
m.mnn
p.valor <- m.mnn/length(sim)
p.valor # p = 0.057


## Exercício 2.

massa.vert <- read.table("body_brain.csv", header = TRUE, sep = ";", dec = ",")
massa.vert <- na.omit(massa.vert)
head(massa.vert)

# 2.1. Calcule a inclinação da relação log(brain) ~ log(body)

par(mfrow = c(1,1))
plot(log(brain) ~ log(body), data = massa.vert)
lm.massa <- lm(log(brain) ~ log(body), data = massa.vert)
abline(lm.massa, col = "red")
coef(lm.massa)
inclinacao <- as.numeric(coef(lm.massa)[2])
inclinacao

x <- log(massa.vert$body)
y <- log(massa.vert$brain)
xm <- mean(x)
ym  <- mean(y)
b <- sum((x - xm)*(y - ym))/sum((x - xm)^2)
b

# b = inclinacao

# 2.2. Crie um vetor para guardar o resultado de simulações;
resultado <- rep(NA, 1000)

# 2.3. Guarde o valor observado no objeto criado em 2.2;
resultado[1] = b
resultado

for(k in 2:1000)
{
  # 2.5. Desordene o vetor brain e guarde no objeto sim_brain;
  sim_brain <- sample(massa.vert$brain, replace = TRUE)
  
  #2.6. Calcule a inclinação entre o log(sim_brain) ~ log(body) e guarde no vetor resultado;
  sim.lm <- lm(log(sim_brain) ~ log(massa.vert$body))
  sim.incl <- as.numeric(coef(sim.lm)[2])
  resultado[k] <- sim.incl
}

resultado

# 2.8. Faça o histograma dos valores simulados e compare com o valor observado da inclinação da relação;
quartz()
par(mfrow=c(1,1))
hist(resultado)
abline(v=resultado[1], col="red")

# 2.9. Calcule a probabilidade da inclinação observada ter sido gerada por variáveis que são independentes;

# Calcular a probabilidade de valores de inclinacoes maiores (em modulo) do que b terem sido geradas aleatoriamente:
maiores <- sum(abs(resultado) >= b)
maiores
p.valor.b <- maiores/length(resultado)
p.valor.b # p = 0.001
