#Exercício 7b: Regressão Múltiplas

#Uma estimativa da incerteza na previsão do modelo
babies<- read.table("babies.csv", header=T, sep="\t")
babies
plot(bwt~gestation, data=babies)

babies1<- babies[babies$gestation!=999,]
babies1
plot(bwt~gestation, data=babies1)


a<- seq(min(babies1$gestation), max(babies1$gestation), length.out=100)
a

media.obs<- mean(babies1$gestation)
media.obs

soma.quadrado<- sum(babies1$gestation)
soma.quaddrado

n<- length(babies1$gestation)
n

variancia.y<- var(babies1$bwt)
variancia.y

erro.padrao<- sqrt(variancia.y*(1/n+((a-media.obs)^2)/soma.quadrado))
erro.padrao

modelo1<- lm(babies1$bwt~babies1$gestation)
summary(modelo1)

coef.modelo1<- coef(modelo1)
coef.modelo1

y<- coef.modelo1[1]+coef.modelo1[2]*a
y

grau.lib<- n-2
grau.lib

erro.padrao.t<- qt(0.95, grau.lib)
erro.padrao.t

inter.confi1<- y + (erro.padrao*erro.padrao.t)
inter.confi1
inter.confi2 <- y - (erro.padrao*erro.padrao.t)
inter.confi2

##Gráfico
par(mar=c(5,5,3,3), cex.lab=1.3, cex.axis=1.2, las=1, bty="n")
plot(babies1$bwt ~ babies1$gestation, pch = 19,cex= 1.5,col = rgb(0,1,0, 0.4), ann=F)
axis(1)
axis(2)
mtext("Massa ao nascer (oz)", 1,  line=2.5, cex = 1.5)
mtext("Duração gestação (dias)", 2, line=3, cex = 1.5, las = 0)
abline(modelo1, col="black",lwd=2)
curve((coef.modelo1[1]+(coef.modelo1[2]*x))+(erro.padrao*erro.padrao.t),add=T,col="red",lwd=1,n=100)
curve((coef.modelo1[1]+(coef.modelo1[2]*x))-(erro.padrao*erro.padrao.t),add=T,col="blue",lwd=1,n=100)
polygon(c(rev(a), a), c(rev(y), y),col = rgb(0,0,0,0.5), border = NA)


#Galileu estava certo?

init.h<- c(600, 700, 800, 950, 1100, 1300, 1500)
init.h

h.d<- c(253, 337, 395, 451, 495, 534, 573)
h.d

plot(h.d~init.h, las=1)

mod1 <- lm(h.d~init.h)
summary(mod1)

mod2 <- update(mod1,.~. +I(init.h^2))
summary(mod2)

abline(mod1, col="black")
coef.mod2 <- coef(mod2)
curve(coef.mod2[1]+coef.mod2[2]*x+coef.mod2[3]*x^2, add=T, lty=2, col="green")

anova(mod1,mod2)

mod3 <- update(mod2,.~. +I(init.h^3))
mod3

coef.mod3<- coef(mod3)
curve(coef.mod3[1]+coef.mod3[2]*x+coef.mod3[3]*x^2+coef.mod3[4]*x^3, add=T, lty=1, col="red")

anova(mod2,mod3)

##O polinômio de terceiro grau é o melhor modelo para descrever o conjunto de dados de Galileu, pois a curva se ajusta melhor aos pontos.  


#Massa de recém nascidos
babies <- read.table("babies.csv", header=T,sep="\t")
babies
str(babies)

babies[babies$bwt>=999,] 
babies[babies$gestation>=999,] 
babies[babies$parity>=9,] 
babies[babies$age>=99,] 
babies[babies$height>=99,] 
babies[babies$weight>=999,] 
babies[babies$smoke>=9,] 

babies.1 <- babies[babies$gestation!=999 & babies$age!=99 & babies$height!=99 & babies$weight!=999 & babies$smoke!=9,]

babies.1$parity <- as.factor(babies.1$parity)
babies.1$smoke <- as.factor(babies.1$smoke)
str(babies.1)
babies.1

pairs(babies.1, panel= panel.smooth)

m1.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+parity:weight+parity:smoke+age:height+age:weight+age:smoke+
height:weight+height:smoke+weight:smoke, data=babies.1)
summary(m1.bab)


m2.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+parity:weight+parity:smoke+age:height+age:weight+age:smoke+
height:weight+height:smoke, data=babies.1)
summary(m2.bab)

anova(m1.bab,m2.bab)

m3.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+parity:weight+parity:smoke+age:weight+age:smoke+height:weight+
height:smoke, data=babies.1)
summary(m3.bab)

anova(m2.bab,m3.bab)

m4.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+parity:smoke+age:weight+age:smoke+height:weight+height:smoke,
data=babies.1)
summary(m4.bab)

anova(m3.bab,m4.bab)

m5.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+age:weight+age:smoke+height:weight+height:smoke, data=babies.1)
summary(m5.bab)

anova(m4.bab,m5.bab)

m6.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+age:weight+age:smoke+height:smoke, data=babies.1)
summary(m6.bab)

anova(m5.bab,m6.bab)

m7.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+age:smoke+height:smoke, data=babies.1)
summary(m7.bab)

anova(m6.bab,m7.bab)

m8.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age+
parity:height+height:smoke, data=babies.1)
summary(m8.bab)

anova(m7.bab,m8.bab)

m9.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:height+
height:smoke, data=babies.1)
summary(m9.bab)

anova(m8.bab,m9.bab)

m10.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:height,
data=babies.1)
summary(m10.bab)

anova(m9.bab,m10.bab)

m11.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:weight+gestation:smoke+parity:height, data=babies.1)
summary(m11.bab)

anova(m10.bab,m11.bab)

m12.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
gestation:age+gestation:smoke+parity:height, data=babies.1)
summary(m12.bab)

anova(m11.bab,m12.bab)

m13.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:age+
gestation:smoke+parity:height, data=babies.1)
summary(m13.bab)

anova(m12.bab,m13.bab)

m14.bab <- lm(bwt~gestation+parity+age+height+weight+smoke+gestation:age+
gestation:smoke, data=babies.1)
summary(m14.bab)

anova(m13.bab,m14.bab)

##Os modelos m13.bab e m14.bab são significativamente diferentes, logo o modelo mínimo adequado é o m13.bab

##Diagnóstico do modelo
par(mfrow=c(2,2))
plot(m13.bab)

##A partir dos gráficos, percebe-se que os resíduos tem homogeneidade de variância, estão de acordo com uma distribuição normal e não apresentam alavancagem


