
#Exercicio Aula 7b

bebes <- read.table("babies.csv", header= TRUE, as.is = TRUE, sep= " ")
head(bebes)

summary(bebes)

length(bebes[bebes==c(99.00,999.00)])
bebes[bebes==99]<-NA #excluir dados faltantes, atribuindo NA
bebes[bebes==999]<-NA
summary(bebes)

bebes<-na.omit(bebes) #omitindo os NA
summary(bebes)


n<-length(bwt)

x<-seq(from=min(gestation)-10, 
               to=max(gestation)+10, length=100)
media<-mean(gestation)

ssx<-sum((gestation-media)^2)

s2<-var(bwt)
se.y<-sqrt(s2*((1/n)+((x-media)^2/ssx)))

lm.bebes<-lm(bwt~gestation)

y<-lm.coefficients[1]+lm.coefficients[2]*x

icmax.y<-y+se.y
icmin.y<-y-se.y

#onde:
# SSX: soma dos desvios quadraticos dos valores de x observados;
#s2: variancia dos valores de y observados;
#n: numero de observacoes;
#x : valor da variavel preditora para o qual se quer estimar o erro padrao;
#x¯ : media dos valores de x observados.

par(c(1,1), cex.lab=1.3, cex.axis=1.1, las=1,bg = "gray70", bty="n")
plot(bwt~gestation, pch = 19,cex= 1.5,
     xlim=range(gestation),
     ylim= range(bwt), 
     xlab="Tempo de Gestacao (dias)", 
     ylab="Peso (Kg)",
     col = rgb(0,0,1, 0.4))
abline(lm.bebes, col="red")
polygon(c(rev(x), x), c(rev(icmax.y), icmin.y),
              col = rgb(0,0,0,0.2), border = NA)



##Exercicio Galileu Galilei

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)


mod1 <- lm(h.d~init.h)

mod2 <- update(mod1,.~. +I(init.h^2))

mod3 <- update(mod2,.~. +I(init.h^3))

anova(mod2, mod3)#apresenta diferenca significativa

# o modelo de polinomio de terceiro grau explica melhor os dados do Galileu. 


#Massa de recem-Nascidos

#analisando linearidade das variaveis
pairs(bebes, panel=panel.smooth) #variaveis lineares, no precisa elevar ao quadrado para o modelo full

#correlacao entre as variaveis
panel.cor <- function(x, y, digits = 2, prefix = "", cex.cor, ...)
{
        usr <- par("usr"); on.exit(par(usr))
        par(usr = c(0, 1, 0, 1))
        r <- abs(cor(x, y))
        txt <- format(c(r, 0.123456789), digits = digits)[1]
        txt <- paste0(prefix, txt)
        if(missing(cex.cor)) cex.cor <- 0.8/strwidth(txt)
        text(0.5, 0.5, txt, cex = cex.cor * r)
}
pairs(bebes, upper.panel= panel.cor, lower.panel = panel.smooth)

#modelo full
lm.total<-lm(bwt ~ gestation + 
                     parity + 
                     age + 
                     height + 
                     weight + 
                     smoke + 
                     gestation:parity + 
                     gestation:age + 
                     parity:age + 
                     gestation:height + 
                     parity:height + 
                     age:height + 
                     gestation:weight + 
                     parity:weight + 
                     age:weight + 
                     height:weight + 
                     gestation:smoke + 
                     parity:smoke + 
                     age:smoke + 
                     height:smoke + 
                     weight:smoke + 
                     gestation:parity:age + 
                     gestation:parity:height + 
                     gestation:age:height + 
                     parity:age:height + 
                     gestation:parity:weight + 
                     gestation:age:weight + 
                     parity:age:weight + 
                     gestation:height:weight + 
                     parity:height:weight + 
                     age:height:weight + 
                     gestation:parity:smoke + 
                     gestation:age:smoke + 
                     parity:age:smoke + 
                     gestation:height:smoke + 
                     parity:height:smoke + 
                     age:height:smoke + 
                     gestation:weight:smoke + 
                     parity:weight:smoke + 
                     age:weight:smoke + 
                     height:weight:smoke + 
                     gestation:parity:age:height + 
                     gestation:parity:age:weight + 
                     gestation:parity:height:weight + 
                     gestation:age:height:weight + 
                     parity:age:height:weight + 
                     gestation:parity:age:smoke + 
                     gestation:parity:height:smoke + 
                     gestation:age:height:smoke + 
                     parity:age:height:smoke + 
                     gestation:parity:weight:smoke + 
                     gestation:age:weight:smoke + 
                     parity:age:weight:smoke + 
                     gestation:height:weight:smoke + 
                     parity:height:weight:smoke + 
                     age:height:weight:smoke + 
                     gestation:parity:age:height:weight + 
                     gestation:parity:age:height:smoke + 
                     gestation:parity:age:weight:smoke + 
                     gestation:parity:height:weight:smoke + 
                     gestation:age:height:weight:smoke + 
                     parity:age:height:weight:smoke + 
                     gestation:parity:age:height:weight:smoke,data=bebes)

anova(lm.total) #modelo full


#analise dos modelos
#excluindo as interaes com p-valor alto na anova(modelo full), mantendo apenas as interaes e variaveis com algum tipo de significancia no modelo cheio
lm1<-lm(bwt~gestation+
        parity+
        height+
        weight+
        smoke+
        gestation:age+
        gestation:weight+
        gestation:smoke+
        parity:smoke+
        weight:smoke+
        parity:age:height:weight+
        gestation:parity:age:height:weight:smoke, data=bebes)

anova(lm.total, lm1) #p-valor no significativo, escolha pelo modelo mais simples(lm1)

#modelo sem as interaes com p-valor <0.1 e >0.05 do modelo cheio

lm2<-lm(bwt~gestation+
                parity+
                height+
                weight+
                smoke+
                gestation:age+
                gestation:weight+
                gestation:smoke+
                parity:smoke+
                gestation:parity:age:height:weight:smoke, data=bebes)

anova(lm.total, lm2) ##p-valor no significativo, escolha pelo modelo mais simples(lm2)

##modelo sem as interaes com p-valor <0.05 e >0.01 do modelo cheio
lm3<-lm(bwt~gestation+parity+height+smoke+gestation:age+gestation:smoke+parity:smoke, data=bebes)

anova(lm.total, lm3)##p-valor no significativo, escolha pelo modelo mais simples(lm3)


##modelo sem as interaes com p-valor <0.01 e >0.001 do modelo cheio
lm4<-lm(bwt~gestation+height+smoke+gestation:age+gestation:smoke, data=bebes)

anova(lm.total, lm4) ##p-valor significativo, escolha pelo modelo complexo. Nesse caso, seria o full. 

#mas ao comparar o modelo cheio (lm.total com o lm3, conforme exercicio acima, manteve o lm3)

#olhando o summary do modelo lm3, foram excluda a variavel e interacao com o p-valor no significativo
lm5<-lm(bwt~gestation+
                #parity+
                height+
                smoke+
                #gestation:age+
                gestation:smoke+
                parity:smoke, data=bebes)

anova(lm.total, lm5)# p-valor no significativo, optando-se pelo modelo mais simples (lm5)
#olhando os summary do modelo lm5, todas variaveis e interacoes apresentam um p-valor significativo, entendo sua importancia ao modelo. 

#modelo minimo adequado
summary(lm5)

# Ao compararmos os modelos pelo valor de AIC, o resultado corrobora com a analise anterior. o modelo lm5 apresenta o menor AIC e um menor grau de liberdade, sendo o escolhido como o modelo minimo adequado tambm.

AIC(lm.total, lm1, lm2, lm3, lm4, lm5) 







   