
### 9.2 - Exercicio Analise exploratoria de duas variaveis

#Tarefa: Crie uma funo para sada grfica de anlises exploratrias de duas variveis. Essa sada pode ter por exemplo boxplot, histograma, qq norm e y por x. A funo deve permitir a entrada de dois objetos vetores de mesmo tamanho (x e y). Caso os valores de x e y forem desenhados em um mesmo grfico, defina cores diferentes. As legendas devem ser em portugus e a sada (return) deve apresentar o sumrio das duas variveis e o coeficiente de correlao.

#DICAS:
  
  #Para histogramas com variveis em um mesmo grfico pode ser utilizada a funo multhist() do pacote "plotrix". Baixe, instale o pacote e veja o help da funo.
#Utilize o cdigo do eda.shape, apresentado em aula como ponto de partida.
#Lembre-se que em algumas funes grficas o argumento add=TRUE, adiciona elementos no grfico anterior.

install.packages("plotrix")

x<-rnorm(36, 1,2)
y<-runif(36)


plot.var <- function(x, y, tipo="", col=c(3,4), xlab="Nome Variavel X", ylab="Nome Variavel Y",bty="l", method = c("pearson", "kendall", "spearman"))
{
  cor.var<-cor(x,y, method=method)
  if(length(x)!=length(y))
 {
   stop("x e y com comprimentos diferentes")
 }
  if(tipo=="hist")
     {
    require(plotrix)
    multhist(list(x,y), xlab=xlab, ylab=ylab, col=col)
    }
  if(tipo=="boxplot")
    {
    par(bty="l")
    boxplot(x,y, col=col, xaxt="n")
    axis(side=1, at=c(1,2), labels=c(xlab, ylab))
    }
  if(tipo=="qqnorm")
  {
    
    qqnorm(x, pch=19, col=col[1], yaxt="n", xlab="Quantiles Teoricos", ylab="Quantiles da Amostra", main=NULL)
    par(new=TRUE)
    qqnorm(y, col=col[2], pch=21, xlab="", ylab="", main="")
    legend(x=-2, y=0.7, legend=c(xlab, ylab), pch=c(19, 21), col=col, cex=0.6)
    par(new=F)
  }
  if(tipo=="plot")
  {
   plot(x,y, pch=c(17,19), xlab=xlab, ylab=xlab, col=col)
  }
    return(list=list(sumario.X=summary(x), sumario.Y=summary(y),correlacao=cor.var))
  
}  

  
plot.var(x,y,"hist", method="pearson")
plot.var(x,y,"boxplot", method="spearman")
plot.var(x,y,"qqnorm")
plot.var(x,y,"plot")
  
 