## Exercicio 5.1
saligna<-read.table("http://ecologia.ib.usp.br/bie5782/lib/exe/fetch.php?media=dados:esaligna.csv", sep=",", dec=".", header=T, as.is=T)
head(saligna)
#pch=19 - simbolo de circulo preenchido
#cex=1.4 (aumento de 40% do tamanho)
#col="red"
#x=dap(cm)
#y=Altura(m)
#cex.axis=1.5
#cex.lab=1.7
#tcl=0.3
#las=1
#bty="l"
#main="Eucalypthus saligna", 80%

X11()
plot(saligna$dap, saligna$ht, pch=19, cex=1.4, col="red", xlab= "Distancia na altura do peito(cm)", 
     ylab="Altura(m)", cex.axis=1.5, cex.lab=1.7,tcl=0.3, las=1, bty="l")
mtext("Eucalypthus saligna", side=3,cex=1.8,font=3)#font=3 indica Italico
savePlot("saligna.png", type= "png")


##Exercício 5.2
# a formatação dos parametros globais foram ajustadas permitindo a construção dos 2 gráficos lado a lado
par(mfrow=c(1,2), 
    pch=19,
    cex=1.1, 
    cex.axis=1.2,
    cex.lab=1.3,
    tcl=0.3,
    las=1,
    bty="l")
boxplot(saligna$dap~saligna$talhao, xlab="Talhão", ylab="DAP(cm)")
text(x=1.3, y=23,"a")#posição da legenda encontrada com locator()

#segundo grafico
saligna$talhao.gr<-as.numeric(factor(saligna$talhao, label=1:length(unique(saligna$talhao))))
mean<-tapply(saligna$dap, saligna$talhao.gr, mean)
sd<-tapply(saligna$dap,saligna$talhao.gr, sd)
sd_pos<-mean + (tapply(saligna$dap,saligna$talhao.gr, sd))
sd_neg<-mean - (tapply(saligna$dap,saligna$talhao.gr, sd))

talhao<-as.numeric(rownames(data.frame(mean)))

plot(saligna$dap~saligna$talhao.gr, 
     type="n", #para não parecer nada
     xaxt="n",
     xlab="Talhão", 
     ylab="Média±SD do DAP(cm)")
points(x=talhao, y=sd_pos,pch="-", col="black")
points(x=talhao, y=sd_neg, pch="-", col="black")
segments(x0=talhao,y0=sd_neg, x1=talhao, y1=sd_pos)
points(x=talhao, y=mean, col="red")
axis(side=1, 
     at= talhao, 
     labels=sort(unique(saligna$talhao)))

text(x=6,y=23,"b") #posição da legenda encontrada com locator()

##Ex.5.3
xy<-read.table("http://ecologia.ib.usp.br/bie5782/lib/exe/fetch.php?media=bie5782:01_curso2009:material:exercicio3.csv", sep=",", dec=".", header=T)

par(mfrow=c(1,2),cex.lab=1.3, tcl=0.3,las=1,bty="l")
xy1<-na.omit(xy)

plot(xy1$x1,xy1$y1, 
     xlim=c(0.5,3.0),
     ylim=c(0.0,3.0),
     xlab="Log(Patch size)(ha)", 
     ylab="Euclidean Distances", 
     pch=17)

abline(lm(xy1$y1~xy1$x1), col="black")
text(x=3, y=3, "a")

#graf 2
plot(x=c(1,2,2.90,3.10,4,4.80,5,5.20), y=rep(3,8), 
     pch="*", 
     xlim=c(0.0,7.0),
     ylim=c(0.0,3.0), 
     xlab="",
     ylab="", 
     xaxt="n")

par(new=TRUE)
boxplot(xy$x2[-27]~xy$y2[-27], 
        ylim=c(0.0,3.0),
        xlab="",
        ylab="", 
        xaxt="n", 
        outline=F)#excluindo um ponto outline
axis(side=1, at=c(1:6), label= c("Small", "Median\nEdge", "Median\nInterior", "Large\nEdge", "Large\nInterior", "Control"), cex.axis=0.7)

text(x=6.5,y=3,"b")

